import React, { type FC, type ReactNode } from "react";
type ProviderProps<TArgs extends any[]> = {
    children?: ReactNode;
    args?: TArgs;
};
type Result<TValue, TName extends string, TArgs extends any[]> = {
    [K in `use${TName}` | `${TName}Provider` | `with${TName}`]: K extends `use${TName}` ? () => TValue : K extends `${TName}Provider` ? FC<ProviderProps<TArgs>> : K extends `with${TName}` ? <TProps extends object>(WrappedComponent: React.ComponentType<TProps>) => (props: TProps) => JSX.Element : never;
};
declare function typesafeContextHook<TName extends string, TValue = any, TArgs extends any[] = []>(name: TName, hook: (...args: TArgs) => TValue): Result<TValue, TName, TArgs>;
export default typesafeContextHook;
